unit Main;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, Preview, ExtCtrls, StdCtrls, Menus, ToolWin, ComCtrls,
  mdCONTROLS, ImgList, PASpinEdit, PAStatus, jpeg, FreeRaportHeader, Printers;

const
  CoverRegKey = 'Software\ZLDO\MuzCat';

type
  TWorkPlace = record
    PageIndex:integer;
    WorkRect:TRect;
  end;

  TTwoRect = record
    r1,r2:TRect;
  end;

  TForm1 = class(TForm)
    PrintPreview1: TPrintPreview;
    PrintDialog1: TPrintDialog;
    PopupMenu1: TPopupMenu;
    N501: TMenuItem;
    N1001: TMenuItem;
    N1501: TMenuItem;
    N2001: TMenuItem;
    N1: TMenuItem;
    XPToolBar1: TXPToolBar;
    ToolButton1: TToolButton;
    ImageList1: TImageList;
    ToolButton2: TToolButton;
    ToolButton3: TToolButton;
    ToolButton4: TToolButton;
    ToolButton5: TToolButton;
    ToolButton6: TToolButton;
    ToolButton7: TToolButton;
    ComboBox1: TComboBox;
    ToolButton8: TToolButton;
    ToolButton9: TToolButton;
    Label2: TLabel;
    ToolButton10: TToolButton;
    ToolButton13: TToolButton;
    N2: TMenuItem;
    N3: TMenuItem;
    ToolButton12: TToolButton;
    Image1: TImage;
    XPStatusBar1: TXPStatusBar;
    OpenDialog1: TOpenDialog;
    SaveDialog1: TSaveDialog;
    ToolButton11: TToolButton;
    ToolButton14: TToolButton;
    procedure Button1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure ComboBox1Select(Sender: TObject);
    procedure N3Click(Sender: TObject);
    procedure ToolButton12Click(Sender: TObject);
    procedure ToolButton10Click(Sender: TObject);
    procedure ToolButton4Click(Sender: TObject);
    procedure ToolButton11Click(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
  private
    { Private declarations }
    ColumnWidth:integer;
    CurTop,CurLeft,CurColumn:integer;
    FoneBitMap: TPicture;
    procedure Init_Simple;
    procedure Init_Convert;
    procedure LoadFoneImage;
  public
    { Public declarations }
    function AddPage:TWorkPlace;
    procedure DrawItem(Const Item:TDBRec;Const level:integer;Const ItemNo:integer);
    procedure DrawTitle;


    procedure Init;

    function CanDrawNext(Const WorkRect:TRect):boolean;
    procedure GoToNextColumn;
    procedure SetZoom(Const ZoomMode:integer);
    procedure SetButtonState;
    procedure CreateParams(Var Params:TCreateParams);override;
  end;

procedure SaveConfig;
procedure LoadConfig;
function ParseShablonStr(Const Info:TDBRec;Const Shablon:string):string;



var
  Form1: TForm1;

  ElFont:TFont;
  LevelFont:TFont;
  TitleFont:TFont;
  UseBk:boolean;
  BkFileName:string;
  BkTile:boolean;
  NeedRepeat:boolean = false;
  OwnerWND:THandle; //      
  ColumnCount:integer;
  ItemCount:integer = 1;
  ElShablon, TitleShablon:string;
  TitleHeight:integer = 0;
  TitleRight:integer;
  NeedTitle:boolean;
  FontZoom:integer = 0;
  MaxTreeLevel:integer = -1;
  firstPage:boolean = true;
  CoverTitle:string;
  LastItemIsEl:boolean = true;

  OddPageXMargin:integer = 0;
  OddPageYMargin:integer = 0;

  ProportionalFone: boolean = true;


procedure MyDrawText(Const Canvas:TCanvas;
  Const Text:string;
  Const Rect: TRect;
  Const uFormat: Integer;
  Const EfectColor: TColor;
  Effect: byte = 0);


implementation

uses Types, Registry, Unit2, Unit3;

{$R *.dfm}

var
  CoverRecr1,CoverRecr2:TRect;
  Wcenter:integer;
  Hcenter:integer;
const
  ColumnMargin = 10;


procedure MoveRect(var r: TRect; Const x,y: integer);
begin
  inc(r.Left, x);
  inc(r.Right, x);
  inc(r.Top, y);
  inc(r.Bottom, y);
end;

procedure DrawTextWBorder(Const Canvas:TCanvas;
  Const Text:string;
  Const Rect: TRect;
  Const uFormat: Integer;
  Const BorderColor: TColor);

var
  r: TRect;
  FontColorBuf: TColor;
  b: integer;

begin
  b := 1;

  FontColorBuf := Canvas.Font.Color;
  Canvas.Font.Color := BorderColor;

  r := Rect;
  MoveRect(R,0,-b);
  SetBkMode(Canvas.Handle, TRANSPARENT);
  DrawText(Canvas.Handle,PChar(Text),-1,r, uFormat);

  r := Rect;
  MoveRect(R,0,b);
  SetBkMode(Canvas.Handle, TRANSPARENT);
  DrawText(Canvas.Handle,PChar(Text),-1,r, uFormat);

  r := Rect;
  MoveRect(r,-b,0);
  SetBkMode(Canvas.Handle, TRANSPARENT);
  DrawText(Canvas.Handle,PChar(Text),-1,r, uFormat);

  r := Rect;
  MoveRect(r,b,0);
  SetBkMode(Canvas.Handle, TRANSPARENT);
  DrawText(Canvas.Handle,PChar(Text),-1,r, uFormat);

  Canvas.Font.Color := FontColorBuf;
  r := Rect;
  SetBkMode(Canvas.Handle, TRANSPARENT);
  DrawText(Canvas.Handle,PChar(Text),-1,r, uFormat);

end;

procedure DrawTextWShadow(Const Canvas:TCanvas;
  Const Text:string;
  Const Rect: TRect;
  Const uFormat: Integer;
  Const ShadowColor: TColor);

var
  r: TRect;
  FontColorBuf: TColor;
  b: integer;

begin
  b := 2;

  FontColorBuf := Canvas.Font.Color;
  Canvas.Font.Color := ShadowColor;

  r := Rect;
  MoveRect(r,b,b);
  SetBkMode(Canvas.Handle, TRANSPARENT);
  DrawText(Canvas.Handle,PChar(Text),-1,r, uFormat);

  Canvas.Font.Color := FontColorBuf;
  r := Rect;
  SetBkMode(Canvas.Handle, TRANSPARENT);
  DrawText(Canvas.Handle,PChar(Text),-1,r, uFormat);

end;

procedure MyDrawText(Const Canvas:TCanvas;
  Const Text:string;
  Const Rect: TRect;
  Const uFormat: Integer;
  Const EfectColor: TColor;
  Effect: byte = 0);
var
  r: TRect;
begin
  r := Rect;
  case Effect of
    1: DrawTextWBorder(Canvas, Text, Rect, uFormat, EfectColor);
    2: DrawTextWShadow(Canvas, Text, Rect, uFormat, EfectColor);
    else
      begin
        SetBkMode(Canvas.Handle, Transparent);
        DrawText(Canvas.Handle,PChar(Text),-1,r, uFormat);
      end;
  end;
end;

function CharToInfoStr(Const ch:Char;Const Info:TDBRec):string;
begin
  case ch of
    '1':result:=info.Artist;
    '2':result:=info.Title;
    '3':result:=info.Album;
    '4':result:=info.Date;
    '5':result:=info.Comment;
    '6':result:=info.Genre;
    '7':result:=info.TimeStr;
    '8':result:=info.FileSizeStr;
    '9':result:=info.FileType;
    'n':result:=IntToStr(ItemCount);
    'a':result:=IntToStr(info.TrackNo);
    'b':result:=info.FilePath;
    'c':result:=info.Additional1;
    'd':result:=info.Additional2;
    'e':result:=info.Additional3;
    'f':result:=info.Additional4;
    'g':result:=IntToStr(info.PlayCount);
    else result:=ch;
  end;
end;


function ParseShablonStr(Const Info:TDBRec;Const Shablon:string):string;
var
  LastOpError:boolean;
  x:integer;
  Section:string;

  function DecodeString:string;
  begin
    if x=length(Shablon) then exit;
    result:=CharToInfoStr(Shablon[x+1],Info);
    LastOpError:=result='';
  end;

begin
  result:='';
  LastOpError:=false;
  x:=1;

  while x<=length(Shablon) do
  case Shablon[x] of
    '%':begin
          Section:=Section+DecodeString;
          inc(x,2);
        end;
    '/':begin
          if LastOpError then Section:='';
          result:=result+Section;
          Section:='';
          inc(x);
        end;
    else begin
           Section:=Section+Shablon[x];
           inc(x);
         end;
  end;
  if LastOpError then Section:='';
  result:=result+Section;
end;

function TForm1.AddPage: TWorkPlace;

 function GetRToSt(Const R:TRect):TRect;
 begin
   Result:=R;
   inc(Result.Top);
   inc(Result.Left);
 end;

 function CurCoverRect(Const r:TRect):TRect;
 begin
   result:=r;
   if Odd(PrintPreview1.TotalPages) then
     OffsetRect(Result,OddPageXMargin,OddPageYMargin);
 end;

begin
  CoverRecr1:=Rect(Wcenter,Hcenter,Wcenter+1204,Hcenter+1204);
  CoverRecr2:=Rect(CoverRecr1.Right-3,CoverRecr1.Top,CoverRecr1.Right+1204-1,CoverRecr1.Top+1204);

  CoverRecr1:=CurCoverRect(CoverRecr1);
  CoverRecr2:=CurCoverRect(CoverRecr2);

  CurTop:=CoverRecr1.Top+ColumnMargin;
  CurLeft:=CoverRecr1.Left+ColumnMargin;
  CurColumn:=0;

  firstPage:=false;
  Result.PageIndex:=PrintPreview1.TotalPages;
  with PrintPreview1.Canvas do
  begin
    Pen.Color:=clBlack;
    Pen.Width:=1;

    Brush.Color := ColorSetings.bkColor;

    FillRect(CoverRecr1);
    FillRect(CoverRecr2);

    if UseBk then
    begin
      Brush.Style:=bsClear;
      if BkTile then
      begin
        Brush.Style:=bsSolid;
        Brush.Bitmap:=FoneBitMap.Bitmap;
      end
      else
      begin
        PrintPreview1.PaintGraphicEx(GetRToSt(CoverRecr1), FoneBitMap.Graphic, false, false, true);
        PrintPreview1.PaintGraphicEx(GetRToSt(CoverRecr2), FoneBitMap.Graphic, false, false, true);

        //PrintPreview1.Canvas.StretchDraw(GetRToSt(CoverRecr1),Image1.Picture.Graphic);
        //PrintPreview1.Canvas.StretchDraw(GetRToSt(CoverRecr2),Image1.Picture.Graphic);
      end;
    end;
    Rectangle(CoverRecr1);
    Rectangle(CoverRecr2);
    PrintPreview1.Canvas.Font.Size:=7;
    PrintPreview1.Canvas.Font.Name:='Times New Roman';
    TextOut(CoverRecr1.Left+20,CoverRecr1.Bottom+20,' - '+IntToStr(Result.PageIndex+1));
  end;
end;

procedure TForm1.Button1Click(Sender: TObject);
begin
  PrintPreview1.Clear;
  NeedRepeat:=true;
  Close;
end;

procedure TForm1.Init;
begin
  Init_Simple;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  FoneBitMap := TPicture.Create;
  LoadFoneImage;
  Init;
end;

procedure TForm1.Button2Click(Sender: TObject);
begin
  PrintPreview1.CurrentPage:=PrintPreview1.CurrentPage+1;
  SetButtonState;
end;

procedure TForm1.Button3Click(Sender: TObject);
begin
 PrintPreview1.CurrentPage:=PrintPreview1.CurrentPage-1;
 SetButtonState;
end;

procedure TForm1.Button4Click(Sender: TObject);
begin
  if PrintDialog1.Execute then PrintPreview1.Print;
end;

procedure TForm1.DrawItem(Const Item:TDBRec;Const level:integer;Const ItemNo:integer);
var
  WorkRect:TRect;
  TextToDraw:string;
  bkCol: TColor;
  Efect: byte;

  procedure SetFont;
  begin
    if level=-1 then
    begin
      PrintPreview1.Canvas.Font:=ElFont;
      PrintPreview1.Canvas.Font.Color := ColorSetings.ItemColor;
      bkCol := ColorSetings.ItemBkColor;
      Efect := ColorSetings.ItemUseBk;
    end
    else
    begin
      Efect := ColorSetings.SubTitleUseBk;
      PrintPreview1.Canvas.Font:=LevelFont;
      bkCol := ColorSetings.SubTitleBkColor;
      PrintPreview1.Canvas.Font.Color := ColorSetings.SubTitleColor;
      if MaxTreeLevel>0 then PrintPreview1.Canvas.Font.Size:=PrintPreview1.Canvas.Font.Size+(MaxTreeLevel-Level)*FontZoom;
    end;
  end;

begin
  if level<0 then TextToDraw:=ParseShablonStr(Item,ElShablon)
             else TextToDraw:=ParseShablonStr(Item,TitleShablon);
  if (LastItemIsEl)and(level>=0) then CurTop:=CurTop+ColumnMargin*2;
  repeat
    WorkRect.Left:=CurLeft;
    WorkRect.Top:=CurTop;
    WorkRect.Right:=CurLeft+ColumnWidth;

    SetFont;

    DrawText(PrintPreview1.Canvas.Handle,PChar(TextToDraw),-1,WorkRect,DT_CALCRECT or DT_WORDBREAK or DT_EXPANDTABS);
  until CanDrawNext(WorkRect);

  SetFont;
  SetBkMode(PrintPreview1.Canvas.Handle, Transparent);
  MyDrawText(PrintPreview1.Canvas,TextToDraw ,WorkRect,DT_WORDBREAK or DT_EXPANDTABS, bkCol, Efect);
  //DrawText(PrintPreview1.Canvas.Handle,PChar(),-1,WorkRect,DT_WORDBREAK);
  CurTop:=WorkRect.Bottom;
end;

function TForm1.CanDrawNext(const WorkRect: TRect): boolean;
begin
  Result:=WorkRect.Bottom<=CoverRecr1.Bottom;
  if result then exit
            else GoToNextColumn;
end;

procedure TForm1.GoToNextColumn;
begin
  if (CurColumn+1)<(ColumnCount*2) then
  begin
    CurTop:=CoverRecr1.Top+ColumnMargin;
    CurLeft:=CurLeft+ColumnWidth+ColumnMargin;
    if firstPage then
      if CurLeft<TitleRight+ColumnMargin then
        CurTop:=CurTop + TitleHeight;
    if CurColumn>ColumnCount then CurLeft:=CurLeft+2;
    Inc(CurColumn);
  end
  else
  begin
    PrintPreview1.NewPage;
    AddPage;
  end;
end;



procedure TForm1.ComboBox1Select(Sender: TObject);
begin
  SetZoom((Sender as TComboBox).ItemIndex);
end;

procedure TForm1.SetZoom(const ZoomMode: integer);
begin
  case ZoomMode of
    0: PrintPreview1.Zoom := 50;
    1: PrintPreview1.Zoom := 100;
    2: PrintPreview1.Zoom := 150;
    3: PrintPreview1.Zoom := 200;
    4: PrintPreview1.ZoomState := zsZoomToWidth;
    5: PrintPreview1.ZoomState := zsZoomToHeight;
    6: PrintPreview1.ZoomState := zsZoomToFit;
  end;
end;

procedure TForm1.SetButtonState;
begin
  ToolButton1.Enabled:=PrintPreview1.CurrentPage>1;
  ToolButton2.Enabled:=PrintPreview1.CurrentPage<PrintPreview1.TotalPages;
   XPStatusBar1.Panels[0].Text:=' '+IntToStr(PrintPreview1.CurrentPage)+
                               '  '+IntToStr(PrintPreview1.TotalPages);
end;

procedure TForm1.N3Click(Sender: TObject);
begin
  SetZoom((Sender as TMenuItem).Tag);
  ComboBox1.ItemIndex:=(Sender as TMenuItem).Tag;
end;

function tok(Sep: string;Var s: string):string;

  function isoneof(c,s:string): Boolean;
  var
    iTmp:integer;
  begin
    Result:=False;
    for iTmp:=1 to Length(s) do
      begin
        if c=Copy(s,iTmp,1) then
          begin
            result:=True;
            exit;
          end;
      end;
  end;
var
  c,t: string;
begin
  if s='' then
    begin
      result:=s;
      exit;
    end;
  c:=Copy(s,1,1);
  while isoneof(c,sep) do
    begin
      s:=Copy(s,2,Length(s)-1);
      c:=Copy(s,1,1);
    end;
  t:='';
  while (not isoneof(c,sep)) and (s <>'') do
    begin
      t:=t+c;
      s:=Copy(s,2,length(s)-1);
      c:=Copy(s,1,1);
    end;
  result:=t;
end;


function FontToStr(font: TFont): string;
  procedure yes(var str:string);
  begin
    str:=str+'y';
  end;
  procedure no(var str:string);
  begin
   str:=str+'n';
  end;
begin
  {   TFont  }
  result:='';
  result:=result+IntToStr(font.Color)+'|';
  result:=result+IntToStr(font.Height)+'|';
  result:=result+font.Name+ '|';
  result:=result+IntToStr(Ord(font.Pitch))+'|';
  result:=result+IntToStr(font.PixelsPerInch)+'|';
  result:=result+IntToStr(font.size)+'|';
  if fsBold in font.style then yes(result) else no(result);
  if fsItalic in font.style then yes(result) else no(result);
  if fsUnderline in font.style then yes(result) else no(result);
  if fsStrikeout in font.style then yes(result) else no(result);
end;

procedure StrToFont(Str:string;Font:TFont);
begin
  if str = '' then Exit;
  font.Color := StrToInt(tok('|', str));
  font.Height := StrToInt(tok('|', str));
  font.Name := tok('|', str);
  font.Pitch := TFontPitch(StrToInt(tok('|', str)));
  font.PixelsPerInch := StrToInt(tok('|', str));
  font.Size := StrToInt(tok('|', str));
  font.Style:=[];
  if str[2]='y' then font.Style:=font.Style+[fsBold];
  if str[3]='y' then font.Style:=font.Style+[fsItalic];
  if str[4]='y' then font.Style:=font.Style+[fsUnderline];
  if str[5]='y' then font.Style:=font.Style+[fsStrikeout];
end;


procedure SetColorSettingsToDef;
begin
  with ColorSetings do
  begin
    bkColor := clWhite;
    TitleColor := clBlack;
    SubTitleColor := clBlack;
    ItemColor := clBlack;

    TitleBkColor := clWhite;
    SubTitleBkColor := clWhite;
    ItemBkColor := clWhite;
    TitleUseBk := 0;
    SubTitleUseBk := 0;
    ItemUseBk := 0;
  end;
end;

procedure LoadConfig;
var
  Reg:TRegIniFile;
begin
  SetColorSettingsToDef;
  Reg:=TRegIniFile.Create;
  Reg.OpenKey(CoverRegKey,true);
  try
    StrToFont(Reg.ReadString('CoverPlug','ElFont','0|-8|Georgia|0|96|6|nnnn'),ElFont);
    StrToFont(Reg.ReadString('CoverPlug','LevelFont','0|-11|Arial|0|96|8|ynnn'),LevelFont);
    StrToFont(Reg.ReadString('CoverPlug','TitleFont','0|-21|Arial|0|96|8|ynnn'),TitleFont);
    ColumnCount:=Reg.ReadInteger('CoverPlug','ColumnCount',3);
    UseBk:=Reg.ReadBool('CoverPlug','UseBk',false);
    BkTile:=Reg.ReadBool('CoverPlug','Tile',false);
    BkFileName:=Reg.ReadString('CoverPlug','BkFileName','');
    ElShablon:=Reg.ReadString('CoverPlug','ElShablon','%n. /%1 -/%2 (%7)');
    TitleShablon:=Reg.ReadString('CoverPlug','TitleShablon','<<%2>>');
    NeedTitle:=Reg.ReadBool('CoverPlug','NeedTitle',true);
    FontZoom:=Reg.ReadInteger('CoverPlug','FontZoom',0);
    OddPageXMargin:=Reg.ReadInteger('CoverPlug','OddPageXMargin',0);
    OddPageYMargin:=Reg.ReadInteger('CoverPlug','OddPageYMargin',0);
    Reg.ReadBinaryData('Colors',ColorSetings, SizeOf(TColorSetings));
  finally
    reg.Free;
  end;
end;

procedure SaveConfig;
var
  Reg:TRegIniFile;
begin
  Reg:=TRegIniFile.Create;
  Reg.OpenKey(CoverRegKey,true);
  try
    Reg.WriteString('CoverPlug','ElFont',FontToStr(ElFont));
    Reg.WriteString('CoverPlug','LevelFont',FontToStr(LevelFont));
    Reg.WriteString('CoverPlug','TitleFont',FontToStr(TitleFont));
    Reg.WriteInteger('CoverPlug','ColumnCount',ColumnCount);
    Reg.WriteBool('CoverPlug','UseBk',UseBk);
    Reg.WriteBool('CoverPlug','Tile',BkTile);
    Reg.WriteString('CoverPlug','BkFileName',BkFileName);
    Reg.WriteString('CoverPlug','ElShablon',ElShablon);
    Reg.WriteString('CoverPlug','TitleShablon',TitleShablon);
    Reg.WriteBool('CoverPlug','NeedTitle',NeedTitle);
    Reg.WriteInteger('CoverPlug','FontZoom',FontZoom);
    Reg.WriteInteger('CoverPlug','OddPageXMargin',OddPageXMargin);
    Reg.WriteInteger('CoverPlug','OddPageYMargin',OddPageYMargin);
    Reg.WriteBinaryData('Colors',ColorSetings, SizeOf(TColorSetings));
  finally
    reg.Free;
  end;
end;

procedure TForm1.ToolButton12Click(Sender: TObject);
begin
  Form2:=TForm2.Create(Self,Handle);
  Form2.ShowModal;
  if FileExists(BkFileName) then
  try
    Image1.Picture.LoadFromFile(BkFileName);
  except
    UseBk:=false;
  end
  else UseBk:=false;
  Button1Click(nil);
end;

procedure TForm1.CreateParams(var Params: TCreateParams);
begin
 inherited CreateParams(Params);
 with Params do
   begin
     Style:=(Style or ws_Overlapped);
     ExStyle:=ExStyle and (not WS_EX_APPWINDOW);
     WndParent:=OwnerWND;
   end;
end;

procedure TForm1.ToolButton10Click(Sender: TObject);
begin
  if OpenDialog1.Execute then PrintPreview1.LoadFromFile(OpenDialog1.FileName);
end;

procedure TForm1.ToolButton4Click(Sender: TObject);
begin
  if SaveDialog1.Execute then PrintPreview1.SaveToFile(SaveDialog1.FileName);
end;

procedure TForm1.DrawTitle;
var
  WorkRect:TRect;
begin
 if CoverTitle='' then
 begin
   TitleHeight:=0;
   exit;
 end;
 PrintPreview1.Canvas.Font:=TitleFont;
 WorkRect.Top:=CoverRecr1.Top+ColumnMargin;
 WorkRect.Left:=CurLeft;
 WorkRect.Right:=WorkRect.Left+1204 - ColumnMargin;
 DrawText(PrintPreview1.Canvas.Handle,PChar(CoverTitle),-1,WorkRect,DT_CALCRECT or DT_WORDBREAK  or DT_EXPANDTABS);
 SetBkMode(PrintPreview1.Canvas.Handle, Transparent);
 //PrintPreview1.Canvas.Rectangle(WorkRect);
 PrintPreview1.Canvas.Font.Color := ColorSetings.TitleColor;
 MyDrawText(PrintPreview1.Canvas,CoverTitle ,WorkRect,DT_WORDBREAK or DT_EXPANDTABS, ColorSetings.TitleBkColor, ColorSetings.TitleUseBk);
 TitleHeight:=WorkRect.Bottom-WorkRect.Top;
 TitleRight:=WorkRect.Right;
 CurTop:=CoverRecr1.Top+ColumnMargin + TitleHeight*integer(PrintPreview1.CurrentPage=0);
end;

procedure TForm1.ToolButton11Click(Sender: TObject);
begin
  TForm3.Create(Self).ShowModal;
end;

procedure TForm1.Init_Convert;
begin
  PrintPreview1.Orientation := poPortrait;

  Wcenter:=(PrintPreview1.PaperWidth div 2) - (1204 div 2)*2;
  Hcenter:=(PrintPreview1.PaperHeight div 2) - (1204 div 2);

  CoverRecr1:=Rect(Wcenter,Hcenter,Wcenter+1204,Hcenter+1204);
  CoverRecr2:=Rect(CoverRecr1.Right-3,CoverRecr1.Top,CoverRecr1.Right+1204-1,CoverRecr1.Top+1204);

  ColumnWidth:=((1204-(ColumnCount*ColumnMargin)) div ColumnCount);
end;

procedure TForm1.Init_Simple;
begin
  PrintPreview1.Orientation := poLandscape;

  Wcenter:=(PrintPreview1.PaperWidth div 2) - (1204 div 2)*2;
  Hcenter:=(PrintPreview1.PaperHeight div 2) - (1204 div 2);

  CoverRecr1:=Rect(Wcenter,Hcenter,Wcenter+1204,Hcenter+1204);
  CoverRecr2:=Rect(CoverRecr1.Right-3,CoverRecr1.Top,CoverRecr1.Right+1204-1,CoverRecr1.Top+1204);

  ColumnWidth:=((1204-(ColumnCount*ColumnMargin)) div ColumnCount);
end;

procedure TForm1.FormDestroy(Sender: TObject);
begin
  FoneBitMap.Free;
end;

procedure TForm1.LoadFoneImage;
var
  x: integer;
begin
  if UseBk then
  if FileExists(BkFileName) then
    try
      Image1.Picture.LoadFromFile(BkFileName);
      if ProportionalFone then
      begin
        if Image1.Picture.Width < Image1.Picture.Height then x:= Image1.Picture.Width
                                                        else x:= Image1.Picture.Height;

        FoneBitMap.Bitmap.Width := x;
        FoneBitMap.Bitmap.Height := x;
      end
      else
      begin
        FoneBitMap.Bitmap.Width := Image1.Picture.Width;
        FoneBitMap.Bitmap.Height := Image1.Picture.Height;
      end;
      FoneBitMap.Bitmap.Canvas.Draw(0,0, Image1.Picture.Graphic);
    except
      UseBk:=false;
    end
    else UseBk:=false;
end;

initialization
  ElFont:=TFont.Create;
  LevelFont:=TFont.Create;
  TitleFont:=TFont.Create;
  LoadConfig;
finalization
  Application.Handle := 0;
  SaveConfig;
  ElFont.Free;
  LevelFont.Free;
  TitleFont.Free;
  try
    if Assigned(form1) then Form1.Free;
  except
  end;
end.
