unit Unit2;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, PASpinEdit, mdCONTROLS, ExtDlgs, ExtCtrls, ComCtrls,
  PAComboEdit, ImgList, FreeRaportHeader, Buttons, mdBUTTONS, Menus;

type
  TForm2 = class(TForm)
    Button1: TButton;
    OpenPictureDialog1: TOpenPictureDialog;
    FontDialog1: TFontDialog;
    XPPageControl1: TXPPageControl;
    XPTabSheet1: TXPTabSheet;
    Label1: TLabel;
    PASpinEdit2: TPASpinEdit;
    XPTabSheet2: TXPTabSheet;
    XPTabSheet3: TXPTabSheet;
    Memo1: TMemo;
    Label2: TLabel;
    Label4: TLabel;
    Memo2: TMemo;
    XPGroupBox2: TXPGroupBox;
    XPTabSheet4: TXPTabSheet;
    Memo3: TMemo;
    XPGroupBox1: TXPGroupBox;
    XPCheckBox2: TXPCheckBox;
    Label3: TLabel;
    PASpinEdit1: TPASpinEdit;
    XPGroupBox3: TXPGroupBox;
    Label5: TLabel;
    Label6: TLabel;
    Label7: TLabel;
    PASpinEdit3: TPASpinEdit;
    PASpinEdit4: TPASpinEdit;
    Label8: TLabel;
    Image2: TImage;
    Label9: TLabel;
    Label10: TLabel;
    XPGroupBox4: TXPGroupBox;
    XPCheckBox1: TXPCheckBox;
    XPCheckBox3: TXPCheckBox;
    CheckBox2: TXPCheckBox;
    PAComboEdit1: TPAComboEdit;
    Label11: TLabel;
    Shape1: TShape;
    ColorDialog1: TColorDialog;
    XPGroupBox5: TXPGroupBox;
    XPGroupBox6: TXPGroupBox;
    Label14: TLabel;
    Shape4: TShape;
    Shape5: TShape;
    Button4: TButton;
    XPGroupBox7: TXPGroupBox;
    Bevel1: TBevel;
    Image1: TImage;
    ImageList1: TImageList;
    XPSpeedButton1: TXPSpeedButton;
    PopupMenu1: TPopupMenu;
    N1: TMenuItem;
    N2: TMenuItem;
    N3: TMenuItem;
    N4: TMenuItem;
    Button3: TButton;
    Label13: TLabel;
    XPSpeedButton2: TXPSpeedButton;
    Shape6: TShape;
    Shape7: TShape;
    Shape2: TShape;
    Shape3: TShape;
    XPSpeedButton3: TXPSpeedButton;
    Label12: TLabel;
    Button2: TButton;
    procedure FormCreate(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure Button4Click(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure CheckBox1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Button5Click(Sender: TObject);
    procedure XPCheckBox2Click(Sender: TObject);
    procedure Shape1MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure XPCheckBox4Click(Sender: TObject);
    procedure Memo1Change(Sender: TObject);
    procedure Memo2Change(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure FormPaint(Sender: TObject);
    procedure XPSpeedButton1Click(Sender: TObject);
    procedure N4Click(Sender: TObject);
  private
    { Private declarations }
    FOwnerWnd:THandle;
    TestItemStr: string;
    TestSubItemStr: string;
    TestDBRec: TDBRec;
    SampleBmp: TBitmap;
    procedure CreateParams(Var Params:TCreateParams);override;
  public
    { Public declarations }
    constructor Create(AOwner:TComponent;AOwmerWnd:Thandle);
    procedure SetColorSetingsField(Const FieldTag: integer;Const Value: TColor);
    procedure UpdateFontColorSetView;
    procedure SetTestDBRec;
    procedure UpdateViews;
    procedure DoImageChange;
  end;

  TColorSetings = packed record
    bkColor,
    TitleColor,
    TitleBkColor,
    SubTitleColor,
    SubTitleBkColor,
    ItemColor,
    ItemBkColor: TColor;
    TitleUseBk,
    SubTitleUseBk,
    ItemUseBk: byte;
  end;

const
    ct_bkColor = 0;
    ct_TitleColor = 1;
    ct_TitleBkColor = 2;
    ct_SubTitleColor = 3;
    ct_SubTitleBkColor = 4;
    ct_ItemColor = 5;
    ct_ItemBkColor = 6;

var
  Form2: TForm2;
  ColorSetings: TColorSetings;

implementation

uses Main, Types;

{$R *.dfm}

function EffectToStr(Const Effect: integer):string;
begin
  case Effect of
    1: result := '';
    2: result := '';
  else result := ' ';
  end;

end;

procedure TForm2.FormCreate(Sender: TObject);
begin
  SampleBmp := TBitmap.Create;
  //SampleBmp.Handle := CreateCompatibleBitmap(GetDC(0), PaintBox1.Width, PaintBox1.Height);
  SampleBmp.Height := Bevel1.Height;
  SampleBmp.Width  := Bevel1.Width;

  XPCheckBox1.Checked:=UseBk;
  XPCheckBox2.Checked:=NeedTitle;
  CheckBox2.Checked:=BkTile;
  PASpinEdit1.Value:=columnCount;
  PASpinEdit2.Value:=FontZoom;
  Image2.Picture.Icon.Handle:=LoadIcon(0,IDI_ASTERISK);
  try
    if FileExists(BkFileName) then Image1.Picture.LoadFromFile(BkFileName);
    PAComboEdit1.Text := BkFileName
  except
  end;
  CheckBox1Click(XPCheckBox1);
  Memo1.Text:=ElShablon;
  Memo2.Text:=TitleShablon;
  PASpinEdit3.Value:=OddPageXMargin;
  PASpinEdit4.Value:=OddPageYMargin;

  UpdateViews;

  Shape1.Tag := ct_bkColor;
  Shape1.Tag := ct_bkColor;
  Shape2.Tag := ct_ItemColor;
  Shape3.Tag := ct_ItemBkColor;
  Shape4.Tag := ct_TitleColor;
  Shape5.Tag := ct_TitleBkColor;
  Shape6.Tag := ct_SubTitleColor;
  Shape7.Tag := ct_SubTitleBkColor;

  Memo1.OnChange(Memo1);
  Memo2.OnChange(Memo2);
end;

procedure TForm2.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  UseBk:=XPCheckBox1.Checked;
  BkTile:=CheckBox2.Checked;
  columnCount:=PASpinEdit1.Value;
  ElShablon:=Memo1.Text;
  TitleShablon:=Memo2.Text;
  FontZoom:=PASpinEdit2.Value;
  OddPageXMargin:=PASpinEdit3.Value;
  OddPageYMargin:=PASpinEdit4.Value;
end;

procedure TForm2.FormCloseQuery(Sender: TObject; var CanClose: Boolean);
begin
  if XPCheckBox1.Checked then CanClose:=FileExists(BkFileName)
                       else
                         begin
                           CanClose:=true;
                           BkFileName:='';
                         end;
  if not CanClose then MessageBox(Handle,'  ','',MB_OK or MB_ICONEXCLAMATION);
end;

procedure TForm2.Button4Click(Sender: TObject);
begin
 if OpenPictureDialog1.Execute then
 begin
   BkFileName:=OpenPictureDialog1.FileName;
   Image1.Picture.LoadFromFile(BkFileName);
   PAComboEdit1.Text := BkFileName;
   DoImageChange;
 end;
end;

procedure TForm2.Button1Click(Sender: TObject);
begin
  Close;
end;

procedure TForm2.CheckBox1Click(Sender: TObject);
begin
  CheckBox2.Enabled:=(Sender as TCheckBox).Checked;
  PAComboEdit1.Enabled:=(Sender as TCheckBox).Checked;
  DoImageChange;
end;

procedure TForm2.Button2Click(Sender: TObject);
begin
  FontDialog1.Font:=ElFont;
  if FontDialog1.Execute then
  begin
    ElFont.Assign(FontDialog1.Font);
    DoImageChange;
  end;
end;

procedure TForm2.Button3Click(Sender: TObject);
begin
  FontDialog1.Font:=LevelFont;
  if FontDialog1.Execute then
  begin
    LevelFont.Assign(FontDialog1.Font);
    DoImageChange;
  end;
end;

procedure TForm2.CreateParams(var Params: TCreateParams);
begin
 inherited CreateParams(Params);
 with Params do
   begin
     Style:=(Style or ws_Overlapped);
     ExStyle:=ExStyle and (not WS_EX_APPWINDOW);
     WndParent:=FOwnerWND;
   end;
end;

constructor TForm2.Create(AOwner: TComponent; AOwmerWnd: Thandle);
begin
  FOwnerWnd:=AOwmerWnd;
  inherited Create(AOwner);
end;

procedure TForm2.Button5Click(Sender: TObject);
begin
  FontDialog1.Font:=TitleFont;
  if FontDialog1.Execute then
  begin
    TitleFont.Assign(FontDialog1.Font);
    DoImageChange;
  end;
end;

procedure TForm2.XPCheckBox2Click(Sender: TObject);
begin
 NeedTitle:=(Sender as TCheckBox).Checked;
end;

procedure TForm2.Shape1MouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  ColorDialog1.Color := (Sender as TShape).Brush.Color;
  if ColorDialog1.Execute then
  begin
    (Sender as TShape).Brush.Color := ColorDialog1.Color;
    SetColorSetingsField((Sender as TShape).Tag, (Sender as TShape).Brush.Color);
  end;
end;

procedure TForm2.SetColorSetingsField(const FieldTag: integer;
  const Value: TColor);
begin
  with ColorSetings do
  case FieldTag of
    ct_bkColor: bkColor := Value;
    ct_TitleColor: TitleColor := Value;
    ct_TitleBkColor: TitleBkColor := Value;
    ct_SubTitleColor: SubTitleColor := Value;
    ct_SubTitleBkColor: SubTitleBkColor := Value;
    ct_ItemColor: ItemColor := Value;
    ct_ItemBkColor: ItemBkColor := Value;
  end;
  DoImageChange;
end;

procedure TForm2.UpdateFontColorSetView;
begin
  Shape3.Visible := XPSpeedButton3.Tag <> 0;
  Shape5.Visible := XPSpeedButton1.Tag <> 0;
  Shape7.Visible := XPSpeedButton2.Tag <> 0;
  with ColorSetings do
  begin
    TitleUseBk     := XPSpeedButton1.tag;
    SubTitleUseBk  := XPSpeedButton2.Tag;
    ItemUseBk      := XPSpeedButton3.Tag;
    DoImageChange;
  end;
end;

procedure TForm2.XPCheckBox4Click(Sender: TObject);
begin
  UpdateFontColorSetView;
end;

procedure TForm2.UpdateViews;
begin
  with ColorSetings do
  begin
   Shape1.Brush.Color := bkColor;
   Shape2.Brush.Color := ItemColor;
   Shape3.Brush.Color := ItemBkColor;
   Shape4.Brush.Color := TitleColor;
   Shape5.Brush.Color := TitleBkColor;
   Shape6.Brush.Color := SubTitleColor;
   Shape7.Brush.Color := SubTitleBkColor;

   XPSpeedButton1.tag  := TitleUseBk;
   XPSpeedButton2.Tag  := SubTitleUseBk;
   XPSpeedButton3.Tag  := ItemUseBk;

   XPSpeedButton1.Caption := EffectToStr(XPSpeedButton1.tag);
   XPSpeedButton2.Caption := EffectToStr(XPSpeedButton2.tag);
   XPSpeedButton3.Caption := EffectToStr(XPSpeedButton3.tag);

  end;

  SetTestDBRec;
  UpdateFontColorSetView;
end;

procedure TForm2.Memo1Change(Sender: TObject);
begin
  TestItemStr:=ParseShablonStr(TestDBRec, (Sender as TMemo).Text);
  DoImageChange;
end;

procedure TForm2.SetTestDBRec;
begin
  with TestDBRec do
  begin
    Rate := 4;
    FilePath := 'c:\test\test.mp3';
    Title := 'Title';
    Artist := 'Artist';
    Album := 'Album';
    Comment := 'Comment';
    Genre := 'Genre';
    Date := '(C)2004 ZLDO';
    FileSizeStr := '3,5 Mb';
    TimeStr := '4:50';
    FileType := 'MP3';
    Drive := 'C';
    Folder := 'Test';
    Additional1 := 'Additional 1';
    Additional2 := 'Additional 2';
    Additional3 := 'Additional 3';
    Additional4 := 'Additional 4';
    PlayCount := 5;
    TrackNo := 1;
    BitRate := 128;

  end;

end;

procedure TForm2.Memo2Change(Sender: TObject);
begin
  TestSubItemStr:=ParseShablonStr(TestDBRec, (Sender as TMemo).Text);
  DoImageChange;
end;

procedure TForm2.DoImageChange;
var
  r: TRect;
begin
  with SampleBmp.Canvas do
  begin
    Brush.Color := ColorSetings.bkColor;
    FillRect(ClipRect);
    if XPCheckBox1.Checked then Draw(0,0, Image1.Picture.Graphic);
    R.Top := 3;
    r.Right := Bevel1.ClientWidth;
    R.Left := 3;
    SampleBmp.Canvas.Font := TitleFont;
    SampleBmp.Canvas.Font.Size := SampleBmp.Canvas.Font.Size + 4;
    DrawText(SampleBmp.Canvas.Handle,PChar(''),-1,r,DT_CALCRECT or DT_WORDBREAK  or DT_EXPANDTABS);
    Font.Color := ColorSetings.TitleColor;
    MyDrawText(SampleBmp.Canvas,'' ,r,DT_WORDBREAK or DT_EXPANDTABS, ColorSetings.TitleBkColor, ColorSetings.TitleUseBk);
    R.Top := R.Bottom + 2;
    r.Right := Bevel1.ClientWidth;

    SampleBmp.Canvas.Font := LevelFont;
    SampleBmp.Canvas.Font.Size := SampleBmp.Canvas.Font.Size + 4;
    DrawText(Handle,PChar(TestSubItemStr),-1,r,DT_CALCRECT or DT_WORDBREAK  or DT_EXPANDTABS);
    Font.Color := ColorSetings.SubTitleColor;
    MyDrawText(SampleBmp.Canvas,TestSubItemStr ,r,DT_WORDBREAK or DT_EXPANDTABS, ColorSetings.SubTitleBkColor, ColorSetings.SubTitleUseBk);
    R.Top := R.Bottom + 2;
    r.Right := Bevel1.ClientWidth;

    SampleBmp.Canvas.Font := ElFont;
    SampleBmp.Canvas.Font.Size := SampleBmp.Canvas.Font.Size + 4;
    DrawText(Handle,PChar(TestItemStr),-1,r,DT_CALCRECT or DT_WORDBREAK  or DT_EXPANDTABS);
    Font.Color := ColorSetings.ItemColor;
    MyDrawText(SampleBmp.Canvas,TestItemStr ,r,DT_WORDBREAK or DT_EXPANDTABS, ColorSetings.ItemBkColor, ColorSetings.ItemUseBk);
  end;

  r.TopLeft := Bevel1.ClientToParent(Bevel1.ClientRect.TopLeft);
  r.BottomRight := Bevel1.ClientToParent(Bevel1.ClientRect.BottomRight);

  InvalidateRect(Handle,@r,false);
end;

procedure TForm2.FormDestroy(Sender: TObject);
begin
  SampleBmp.Free;
end;

procedure TForm2.FormPaint(Sender: TObject);
var
  r: TRect;
begin
  BitBlt(Canvas.Handle,Bevel1.Left,Bevel1.Top,Bevel1.Width, Bevel1.Height,SampleBmp.Canvas.Handle,0,0,SRCCOPY);
end;

procedure TForm2.XPSpeedButton1Click(Sender: TObject);
var
  p: TPoint;
begin
  p := (Sender as TSpeedButton).ClientToScreen((Sender as TSpeedButton).ClientRect.TopLeft);
  p.Y :=  p.Y + (Sender as TSpeedButton).ClientRect.Bottom;
  PopupMenu1.Tag := integer(sender);
  PopupMenu1.Popup(p.X, p.Y);
end;

procedure TForm2.N4Click(Sender: TObject);
begin
 with TSpeedButton((Sender as TMenuItem).GetParentMenu.Tag) do
 begin
   Tag := (Sender as TMenuItem).Tag;
   Caption := (Sender as TMenuItem).Caption;
   UpdateFontColorSetView;
 end;
end;

end.



